/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 10/06/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion;

import java.lang.*;
import java.util.*;
import java.util.regex.*;

public class Abbreviator
{
	private static Abbreviator _instance;
	private String[][] abbreviationList =
		{{"APARTMENT","APT"},
		{"ARCADE","ARC"},
		{"ASSOCIATION","ASSN"},
		{"AVENUE","AVE"},
		{"BLOCK","BLK"},
		{"BOULEVARD","BLVD"},
		{"BUILDING","BLDG"},
		{"CENTRE","CTR"},
		{"COMPANY","CO"},
		{"CORPORATION","CORP"},
		{"COURT","CT"},
		{"CRESCENT","CRES"},
		{"DEMARCATION\\sDISTRICT\\sLOT","DD"},
		{"DEPARTMENT","DEPT"},
		{"DRIVE","DR"},
		{"ESTATE","EST"},
		{"FLAT","FLT"},
		{"GARDENS","GDNS"},
		{"GARDEN","GDN"},
		{"HEIGHTS","HTS"},
		{"HEIGHT","HT"},
		{"HOUSE","HSE"},
		{"INLAND\\sLOT","IL"},
		{"KWAI\\sCHUNG\\sTOWN\\sLOT","KCTL"},
		{"LIMITED","LTD"},
		{"MOUNT","MT"},
		{"PHASE","PH"},
		{"QUARTERS","QTRS"},
		{"QUARTER","QTR"},
		{"ROAD","RD"},
		{"SECTION","SECT"},
		{"SQUARE","SQ"},
		{"STREET","ST"},
		{"TOWER","TWR"},
		{"TUEN\\sMUN\\sTOWN\\sLOT","TMTL"},
		{"VILLAGE","VLG"}};
	
	private Abbreviator()
	{
	}
	
	public static synchronized Abbreviator getInstance()
	{
		if (_instance==null)
			_instance = new Abbreviator();
		return _instance;
	}
	
	public String abbreviate(String source)
	{
		String str = source;
		for (int i=0;i<abbreviationList.length;i++)
		{
			Pattern pattern = Pattern.compile(
					"^(.*\\s)?(" + abbreviationList[i][0] + ")(,|\\s|$.*?)",
					Pattern.CASE_INSENSITIVE);
			Matcher matcher = pattern.matcher(str);
			str = matcher.replaceAll("$1" + abbreviationList[i][1] + "$3");
		}
		return str;
	}
}
