/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 10/06/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.ConversionRule;

import hksarg.ogcio.AddressConversion.FreeTextAddress;

public class Rule1 extends Rule
{
	public Rule1()
	{
		super();
	}
	
	public Rule1(int[] dimension)
	{
		super(dimension);
	}
	
	public boolean fire(FreeTextAddress source)
	throws ConvertAddressException
	{
		boolean fired = false;
		int i;
		int sourceTotalCharCount = 0;
		int outputTotalChar = 0;
		int sourceLineTotal = source.getLineTotal();
		
		try
		{
			for (i=0;i<sourceLineTotal;i++)
			{
				sourceTotalCharCount += source.getLine(i).length();
			}
		}
		catch (ArrayIndexOutOfBoundsException ex)
		{
		}
		for (i=0;i<outputDimension.length;i++)
			outputTotalChar += outputDimension[i];
		
		if (sourceTotalCharCount > outputTotalChar)
		{
			if (source.isAbbreviate())
				throw new ConvertAddressException("Input address is too long");
			fired = true;
			source.abbreviate();
		}
		
		return fired;
	}
}
