/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 10/06/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.ConversionRule;

import hksarg.ogcio.AddressConversion.FreeTextAddress;

public class Rule2 extends Rule
{
	public Rule2()
	{
		super();
	}
	
	public Rule2(int[] dimension)
	{
		super(dimension);
	}
	
	public boolean fire(FreeTextAddress source)
	throws ConvertAddressException
	{
		boolean fired = false;
		int i;
		
		if (source.getLineTotal() > outputDimension.length)
		{
			for (i=0;i<outputDimension.length && i<source.getLineTotal()-1;i++)
			{
//				int charCount = source.getLine(i).length()
//						+ source.getLine(i+1).length() + 1;
				int charCount = FreeTextAddress.mergeAddressString(source.getLine(i),source.getLine(i+1)).length();
				if (charCount <= outputDimension[i])
				{
					fired = true;
					try
					{
						source.mergeLines(i,i+1);
						if (source.getLineTotal() <= outputDimension.length)
							break;
						else
							i--;
					}
					catch (ArrayIndexOutOfBoundsException ex)
					{
						ex.printStackTrace();
						continue;
					}
				}
			}
		}
		
		return fired;
	}
}
