/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 10/06/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.ConversionRule;

import hksarg.ogcio.AddressConversion.FreeTextAddress;

public class Rule3 extends Rule
{
	public Rule3()
	{
		super();
	}
	
	public Rule3(int[] dimension)
	{
		super(dimension);
	}
	
	public boolean fire(FreeTextAddress source)
	throws ConvertAddressException
	{
		int i;
		int numSourceLine = source.getLineTotal();
		
		for (i=0;i<source.getLineTotal();i++)
		{
			if (i >= outputDimension.length)
				break;
			if (source.getLine(i).length() > outputDimension[i])
			{
				return mergeDown(source,i);
			}
		}
		
		return false;
	}
	
	protected boolean mergeDown(FreeTextAddress source, int lineNum)
	{
		boolean isLineAltered = false;
		if (lineNum == source.getLineTotal()
				&& lineNum >= outputDimension.length-1)
			return false;
		
		String line = source.getLine(lineNum);
		String lineBelow;
		if (lineNum+1 >= source.getLineTotal())
			lineBelow = new String();
		else
			lineBelow = source.getLine(lineNum+1);
		String[] token = source.getToken(lineNum);
		int fromIndex = line.length();
		// try to move tokens into next line
		for (int i=token.length-1;i>=0;i--)
		{
			fromIndex = line.lastIndexOf(token[i],fromIndex);
			if (line.substring(0,fromIndex).trim().length() > outputDimension[lineNum])
				continue;
			else
			{
				if (fromIndex > 0)
				{
					lineBelow = FreeTextAddress.mergeAddressString(line.substring(fromIndex),lineBelow);
					isLineAltered = true;
				}
				break;
			}
		}
		// if cannot move token into next line
		// force break between words and try again
		if (!isLineAltered)
		{
			token = source.getToken(lineNum,true);
			fromIndex = line.length();
			for (int i=token.length-1;i>=0;i--)
			{
				fromIndex = line.lastIndexOf(token[i],fromIndex);
				if (line.substring(0,fromIndex).trim().length() > outputDimension[lineNum])
					continue;
				else
				{
					lineBelow = FreeTextAddress.mergeAddressString(line.substring(fromIndex),lineBelow);
					isLineAltered = true;
					break;
				}
			}
		}
		
		if (isLineAltered && fromIndex > 0)
		{
			source.replaceLine(lineBelow,lineNum+1);
			source.replaceLine(line.substring(0,fromIndex).trim(),lineNum);
			return true;
		}
		return false;
	}
}
