/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 10/06/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.ConversionRule;

import java.util.*;

public class RuleFactory
{
	protected static int MAX_RULE_LOAD = 5;
	
	public RuleFactory()
	{
	}
	
	public Rule[] getRules(int[] dimension)
	{
		Vector rules = new Vector(MAX_RULE_LOAD);
		for (int i=0;i<=MAX_RULE_LOAD;i++)
		{
			String className = "hksarg.ogcio.AddressConversion.ConversionRule.Rule" + i;
			try
			{
				Rule aRule = (Rule)this.getClass().getClassLoader().loadClass(className).newInstance();
				aRule.setOutputDimension(dimension);
				rules.add(aRule);
			}
			catch (ClassNotFoundException ex)
			{
			}
			catch (Exception ex1)
			{
				ex1.printStackTrace();
			}
		}
		return (Rule[])rules.toArray(new Rule[rules.size()]);
	}
}
