/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 10/06/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.Tokenizer;

import java.util.regex.*;

public class ChineseBlockFuzzyToken extends FuzzyToken
{
	private static final String DEFAULT_TOKEN = "[y].*?";
	
	private static final double LINGUISTIC_DECAY = 0.33;
	
	protected ChineseBlockFuzzyToken(String[] wordArray, int wordPosition)
	throws ArrayIndexOutOfBoundsException
	{
		super(wordArray,wordPosition);
		init(wordArray,wordPosition);
	}
	
	public static FuzzyToken getInstance(String[] wordArray, int wordPosition)
	{
		try
		{
			Pattern p = Pattern.compile(DEFAULT_TOKEN);
			Matcher m = p.matcher(wordArray[wordPosition]);
			if(m.matches())
			{
				return new ChineseBlockFuzzyToken(wordArray,wordPosition);
			}
		}
		catch (PatternSyntaxException e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	private void init(String[] wordArray, int wordPosition)
	{
		linguistic[wordPosition] = 1.0;
		
		int i;
		double currentLinguistic = linguistic[wordPosition];
		for (i=wordPosition-1;i>=0;i--)
		{
			currentLinguistic *= LINGUISTIC_DECAY;
			
			if (currentLinguistic > DEFAULT_WORD_LINGUISTIC)
				linguistic[i] = currentLinguistic;
			else
				break;
		}
	}
}
