/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 23/07/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.Tokenizer;

import java.util.regex.*;

public class ChineseHKRegionFuzzyToken extends GroupBasedFuzzyToken
{
	private static final String[] DEFAULT_2_WORD_TOKEN = 
			{"\\s*","E\\s*s","s\\s*"};
	private static final double DEFAULT_AREA_LINGUISTIC = 0.26;
	
	protected ChineseHKRegionFuzzyToken(String[] wordArray, int wordPosition, int extendCount)
	throws ArrayIndexOutOfBoundsException
	{
		super(wordArray,wordPosition);
		init(wordPosition,extendCount);
		skipWordNumber = extendCount;
	}
	
	public static FuzzyToken getInstance(String[] wordArray, int wordPosition)
	{
		if (wordPosition > wordArray.length-2)
			return null;
		for (int i=0;i<DEFAULT_2_WORD_TOKEN.length;i++)
		{
			try
			{
				Pattern p = Pattern.compile(".*?" + DEFAULT_2_WORD_TOKEN[i] + ".*?");
				Matcher m = p.matcher(wordArray[wordPosition] + wordArray[wordPosition+1]);
				if(m.matches())
				{
					return new ChineseHKRegionFuzzyToken(wordArray,wordPosition,1);
				}
			}
			catch (PatternSyntaxException e)
			{
				e.printStackTrace();
			}
		}
		return null;
	}
	
	private void init(int wordPosition, int extendCount)
	{
		for (int i=0;i<=extendCount;i++)
		{
			linguistic[wordPosition+i] = DEFAULT_AREA_LINGUISTIC;
		}
	}
}
