/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 26/07/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.Tokenizer;

import java.util.regex.*;

public class ChineseNumberPrefixFuzzyToken extends GroupBasedFuzzyToken
{
	private static final String DEFAULT_TOKEN = "";
	private static final double DEFAULT_LINGUISTIC = GroupBasedFuzzyToken.DEFAULT_LINGUISTIC_MINIMUM;
	//private static final double DEFAULT_LINGUISTIC_AFTER = 0.1001;
	
	protected ChineseNumberPrefixFuzzyToken(String[] wordArray, int wordPosition)
	throws ArrayIndexOutOfBoundsException
	{
		super(wordArray,wordPosition);
		init(wordArray,wordPosition);
	}
	
	public static FuzzyToken getInstance(String[] wordArray, int wordPosition)
	{
		if (wordPosition < wordArray.length-1)
		{
			try
			{
				Pattern p = Pattern.compile(DEFAULT_TOKEN);
				Matcher m = p.matcher(wordArray[wordPosition]);
				if(m.matches())
				{
					if (ChineseNumberFuzzyToken.getInstance(wordArray,wordPosition+1) != null)
					{
						return new ChineseNumberPrefixFuzzyToken(wordArray,wordPosition);
					}
					else if (RangeFuzzyToken.getInstance(wordArray,wordPosition+1) != null)
					{
						return new ChineseNumberPrefixFuzzyToken(wordArray,wordPosition);
					}
					else
					{
						FuzzyToken nextToken = new DefaultFuzzyToken(wordArray,wordPosition+1);
						if (nextToken.isNumber())
							return new ChineseNumberPrefixFuzzyToken(wordArray,wordPosition);
					}
				}
			}
			catch (PatternSyntaxException e)
			{
				e.printStackTrace();
			}
		}
		
		return null;
	}
	
	private void init(String[] wordArray, int wordPosition)
	{
		linguistic[wordPosition] = DEFAULT_LINGUISTIC;
		linguistic[wordPosition+1] = DEFAULT_LINGUISTIC;
	}
}
