/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 03/08/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.Tokenizer;

import java.util.regex.*;

public class ChineseNumberUnitFuzzyToken extends GroupBasedFuzzyToken
{
	private static final String DEFAULT_TOKEN = "[].*?";
	private static final double DEFAULT_LINGUISTIC = GroupBasedFuzzyToken.DEFAULT_LINGUISTIC_MINIMUM;
	//private static final double DEFAULT_LINGUISTIC_AFTER = 0.1001;
	
	protected ChineseNumberUnitFuzzyToken(String[] wordArray, int wordPosition)
	throws ArrayIndexOutOfBoundsException
	{
		super(wordArray,wordPosition);
		init(wordArray,wordPosition);
	}
	
	public static FuzzyToken getInstance(String[] wordArray, int wordPosition)
	{
		if (wordPosition > 0)
		{
			try
			{
				Pattern p = Pattern.compile(DEFAULT_TOKEN);
				Matcher m = p.matcher(wordArray[wordPosition]);
				if(m.matches())
				{
					return new ChineseNumberUnitFuzzyToken(wordArray,wordPosition);
				}
			}
			catch (PatternSyntaxException e)
			{
				e.printStackTrace();
			}
		}
		
		return null;
	}
	
	private void init(String[] wordArray, int wordPosition)
	{
		linguistic[wordPosition-1] = DEFAULT_LINGUISTIC;
		linguistic[wordPosition] = DEFAULT_LINGUISTIC;
		//if (wordPosition+1 < wordArray.length)
			//linguistic[wordPosition+1] = DEFAULT_LINGUISTIC_AFTER;
	}
}
