/*
 * Address Conversion Tool
 *
 * Organization : OGCIO(E)11A
 * Last modified: 20/07/2004
 *
 * @author TH HEUNG
 * @version 1.0
*/

package hksarg.ogcio.AddressConversion.Tokenizer;

import java.util.regex.*;

public class ChineseRangeFuzzyToken extends GroupBasedFuzzyToken
{
	private static final String DEFAULT_TOKEN = "[Φܢw].*?";
	private static final double DEFAULT_LINGUISTIC = GroupBasedFuzzyToken.DEFAULT_LINGUISTIC_MINIMUM;
	
	protected ChineseRangeFuzzyToken(String[] wordArray, int wordPosition)
	throws ArrayIndexOutOfBoundsException
	{
		super(wordArray,wordPosition);
		init(wordPosition);
	}
	
	public static FuzzyToken getInstance(String[] wordArray, int wordPosition)
	{
		if (wordPosition > wordArray.length-2 || wordPosition == 0)
			return null;
		try
		{
			Pattern p = Pattern.compile(DEFAULT_TOKEN,Pattern.CASE_INSENSITIVE);
			int i=0;
			Matcher m = p.matcher(wordArray[wordPosition+i]);
			if (m.matches())
				return new ChineseRangeFuzzyToken(wordArray,wordPosition);
		}
		catch (PatternSyntaxException e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	private void init(int wordPosition)
	{
		for (int i=wordPosition-1; i<=wordPosition+1;i++)
			linguistic[i] = DEFAULT_LINGUISTIC;
	}
}
